<template>
  <!-- 保温箱管理 -->
  <div>
    <actionBar :operateList="operateList" :formList="formList" :ruleForm="searchRuleForm" @openModel="openModel"
      @searchProtocol="searchProtocol"></actionBar>
    <div class="card_content">
      <!-- 表单 -->
      <tables :tableList="tableList" :tableData="tableData" @buttonData="buttonData"></tables>
      <!-- 分页 -->
      <div v-if="Total">
        <pagination :total="Total" :currentPage="Pagination.PageIndex" @changeSize="changeSize"
          @changeCurrent="changeCurrent">
        </pagination>
      </div>
    </div>
    <el-dialog :title="staffTitle" :visible.sync="staffDialogVisible" width="600px" :close-on-click-modal="false"
      @close="closeDialog">
      <forms ref="childRules" :formNewList="formRuleList" :ruleForm="ruleForm" labelWidth="100px"></forms>
      <span slot="footer" class="dialog-footer" v-if="operationType != 'logs'">
        <el-button plain @click="staffDialogVisible = false">取 消</el-button>
        <el-button type="primary" :loading="confirmLoading" @click="handleAdd">确 定</el-button>
      </span>
    </el-dialog>
    <div class="management_card">
      <el-dialog :visible.sync="importDialogVisible" width="500px" :close-on-click-modal="false" @close="closeDialogil">
        <div class="card_search_input">
          <div class="title_search">名称：</div>
          <el-input v-model="nameTitle" placeholder="请输入内容" @input="incubatorInput"></el-input>
        </div>
        <div class="card_import">
          <!-- 表单 -->
          <tables ref="refIncubator" :tableList="incubatorList" :tableData="incubatorData"></tables>
          <!-- 分页 -->
          <div v-if="Total">
            <pagination :total="Total1" :currentPage="Paginationil.PageIndex" :pager-countnum="5"
              layout="sizes, prev, pager, next" @changeSize="changeSizeil" @changeCurrent="changeCurrentil">
            </pagination>
          </div>
        </div>
        <forms ref="incubatorRules" labelPosition="left" :formNewList="stateRuleList" :ruleForm="stateRuleForm"
          labelWidth="80px"></forms>
        <span slot="footer" class="dialog-footer">
          <el-button plain @click="importDialogVisible = false">取 消</el-button>
          <el-button type="primary" :loading="incubatorLoading" @click="incubatorAdd">导 入</el-button>
        </span>
      </el-dialog>
    </div>
  </div>
</template>

<script>
  import {
    getSysUserBind
  } from '@/api/user'
  import {
    getCoolerBox,
    getCoolerBoxDetails,
    addCoolerBox,
    putCoolerBox,
    delCoolerBox,
    getDevice,
    addCoolerBoxImport
  } from '@/api/incubator'
  import actionBar from '@/components/actionBar'
  import tables from '@/components/tables'
  import pagination from '@/components/pagination'
  import forms from '@/components/forms'
  import {
    formRules,
    employee,
    incubator
  } from "./incubator.js";
  import {
    startStatus
  } from '@/assets/js/blockSort'
  export default {
    name: 'IncubatorManagement',
    components: {
      actionBar,
      tables,
      pagination,
      forms
    },
    data() {
      return {
        operateList: [{
          type: 'add',
          title: '添加保温箱',
          icon: 'el-icon-plus',
        }, {
          type: 'import',
          title: '冷链平台导入',
          icon: 'el-icon-upload',
        }],
        formList: [{
          type: 'input',
          label: '名称',
          field: 'name',
          placeholder: '名称',
        }, {
          type: 'input',
          label: 'SN',
          field: 'sn',
          placeholder: 'SN',
        }],
        searchRuleForm: {
          name: '',
          sn: '',
        },
        Pagination: {
          PageIndex: 1,
          PageSize: 10,
        },
        Total: 0,
        tableData: [],
        operationType: '',
        tableList: employee(),
        staffTitle: '添加',
        staffDialogVisible: false,
        formRuleList: [],
        ruleForm: {
          name: '',
          sn: '',
          status: '',
        },
        confirmLoading: false,
        selectingData: {},
        importDialogVisible: false,
        incubatorList: incubator(),
        incubatorData: [],
        Total1: 0,
        Paginationil: {
          PageIndex: 1,
          PageSize: 10,
        },
        stateRuleList: [{
          field: 'status',
          label: '状态',
          placeholder: '状态',
          type: 'radio',
          colWidth: 24,
          rules: [{
            required: true,
            message: '选择状态',
            trigger: 'change'
          }],
          options: startStatus()
        }],
        stateRuleForm: {
          status: '',
        },
        nameTitle: '',
        incubatorLoading: false,
      }
    },
    mounted() {
      const dataList = formRules();
      this.formRuleList = dataList;
      this.getList()
    },
    methods: {
      // 搜索
      searchProtocol(value) {
        this.searchValue = value
        this.getList()
      },
      // 获取订单列表
      getList() {
        var params = {
          page: this.Pagination.PageIndex,
          pageSize: this.Pagination.PageSize,
          ...this.searchValue
        }
        getCoolerBox(params).then(res => {
          if (res.code == 200) {
            this.tableData = res.data.list
            this.Total = res.data.count
          }
        })
      },
      // 选项赋值
      optionMatching(value, field) {
        this.formRuleList.forEach((item, index) => {
          if (item.field == field) {
            item.options = value
          }
        })
      },
      // 弹窗表单添加
      handleAdd() {
        let flag = this.$refs['childRules'].validateForm();
        if (flag) {
          if (this.operationType == 'add') {
            this.confirmLoading = true
            var params = {
              ...this.ruleForm
            }
            addCoolerBox(params).then(res => {
              if (res.code == 200) {
                this.$message({
                  message: '操作成功',
                  type: 'success'
                });
                this.getList()
                this.staffDialogVisible = false
              }
              this.confirmLoading = false
            }).catch(() => {
              this.confirmLoading = false
            })
          } else if (this.operationType == 'edit') {
            this.confirmLoading = true
            var params = {
              id: this.selectingData.id,
              name: this.ruleForm.name,
              sn: this.ruleForm.sn,
              status: this.ruleForm.status,
            }
            putCoolerBox(params).then(res => {
              if (res.code == 200) {
                this.$message({
                  message: '操作成功',
                  type: 'success'
                });
                this.getList()
              }
              this.staffDialogVisible = false
              this.confirmLoading = false
            }).catch(() => {
              this.confirmLoading = false
            })
          }
        } else {
          this.$message.error('表单信息不完整，请继续填写完整');
        }
      },
      buttonData(row, type) {
        this.selectingData = row
        this.operationType = type
        if (type == 'edit') {
          this.staffTitle = '编辑'
          this.staffDialogVisible = true
          setTimeout(() => {
            this.$nextTick(() => {
              this.ruleForm = JSON.parse(JSON.stringify(row))
            })
          })
        } else if (type == 'del') {
          this.deleteUser(row.id)
        } else if (type == 'logs') {
          this.staffTitle = '详情'
          this.staffDialogVisible = true
          this.formRuleList.forEach((item, index) => {
            item.disabled = true
          })
          this.ruleForm = JSON.parse(JSON.stringify(row))
        }
      },
      openModel(type) {
        if (type == 'add') {
          this.staffTitle = '添加'
          this.staffDialogVisible = true
          this.operationType = type
        } else if (type == 'import') {
          this.importDialogVisible = true
          this.getDeviceList()
        }
      },
      // 获取设备列表
      getDeviceList() {
        var params = {
          page: this.Paginationil.PageIndex,
          pageSize: this.Paginationil.PageSize,
          name: this.nameTitle,
        }
        getDevice(params).then(res => {
          if (res.code == 200) {
            this.incubatorData = res.data.list
            this.Total1 = res.data.count
          }
        })
      },
      // 搜索保温箱
      incubatorInput(value) {
        this.nameTitle = value
        this.getDeviceList()
      },
      // 批量导入保温箱
      incubatorAdd() {
        const arrID = this.$refs.refIncubator.waybillIds
        let arr1 = []
        arrID.forEach(item => {
          let arr2 = {
            sn: item.T_sn,
            name: item.T_devName,
          }
          arr1.push(arr2)
        })
        let flag = this.$refs['incubatorRules'].validateForm();
        if (flag) {
          if (arr1.length > 0) {
            this.incubatorLoading = true
            let params = {
              list: arr1,
              ...this.stateRuleForm,
            }
            addCoolerBoxImport(params).then(res => {
              if (res.code == 200) {
                this.$message({
                  message: '操作成功',
                  type: 'success'
                });
                this.getList()
                this.importDialogVisible = false
              }
              this.incubatorLoading = false
            })
          }
        } else {
          this.$message.error('表单信息不完整，请继续填写完整');
        }
      },
      // 删除公司
      deleteUser(id) {
        this.$confirm('此操作将永久删除该车辆, 是否继续?', '提示', {
          confirmButtonText: '确定',
          cancelButtonText: '取消',
          type: 'warning'
        }).then(() => {
          delCoolerBox({
            id: id,
          }).then(res => {
            if (res.code == 200) {
              this.$message({
                message: '操作成功',
                type: 'success'
              });
              this.getList()
            }
          })
        }).catch(() => {});
      },
      changeSize(val) {
        this.Pagination.PageSize = val
        this.getList()
      },
      changeCurrent(val) {
        this.Pagination.PageIndex = val
        this.getList()
      },
      changeSizeil(val) {
        this.Paginationil.PageSize = val
        this.getDeviceList()
      },
      changeCurrentil(val) {
        this.Paginationil.PageIndex = val
        this.getDeviceList()
      },
      // 清空表单
      closeDialog() {
        this.formRuleList.forEach((item, index) => {
          item.disabled = false
        })
        this.ruleForm = {}
        this.$refs.childRules.resetCheck();
      },
      closeDialogil() {
        this.$refs.incubatorRules.resetCheck();
        this.$refs.refIncubator.clearSelected();
      }
    }
  }
</script>

<style lang="scss" scoped>
  .card_check_title {
    display: flex;
    align-items: center;
  }

  .icon_import {
    margin-right: 5px;
    font-size: 20px;
  }

  .card_import {
    box-shadow: 0 2px 12px 0 rgba(0, 0, 0, 0.1);
    margin-bottom: 20px;
  }

  .management_card ::v-deep .el-dialog__body {
    padding: 0px 20px !important;
  }

  .card_search_input {
    display: flex;
    align-items: center;
    margin: 20px 0px 15px 0px;
  }

  .title_search {
    flex: none;
    margin-right: 5px;
  }
</style>
